
 
const St = imports.gi.St;
const Mainloop = imports.mainloop;
const Main = imports.ui.main;




const Clutter = imports.gi.Clutter;
const Lang = imports.lang;



const Search = imports.ui.search;

const searchProviders = Main.overview._viewSelector._searchTab._searchSystem._providers;

function langSearchProvider(title, interpretations) {
    this._init(title, interpretations);
global.log(57)
}

langSearchProvider.prototype = {
    __proto__: Search.SearchProvider.prototype,

    _init: function(title, interpretations) {
        Search.SearchProvider.prototype._init.call(this, title);
        this._buildTemplates(interpretations);
        this.lang=interpretations[0];
    },

   _buildTemplates: function(interpretations) {
        this.templates = [];
    },


    
    _swichlayout: function(terms){
        global.log('lang'+this.lang);
        var replaceArr=Array();
        if (this.lang=='ru'){
            replaceArr={'q':'\u0439',
                        'w':'\u0446',
                        'e':'\u0443',
                        'r':'\u043a',
                        't':'\u0435',
                        'y':'\u043d',
                        'u':'\u0433',
                        'i':'\u0448',
                        'o':'\u0449',
                        'p':'\u0437',
                        '[':'\u0445',
                        ']':'\u044a',
                        '`':'\u0451',
                        'a':'\u0444',
                        's':'\u044b',
                        'd':'\u0432',
                        'f':'\u0430',
                        'g':'\u043f',
                        'h':'\u0440',
                        'j':'\u043e',
                        'k':'\u043b',
                        'l':'\u0434',
                        ';':'\u0436',
                        "'":'\u044d',
                        'z':'\u044f',
                        'x':'\u0447',
                        'c':'\u0441',
                        'v':'\u043c',
                        'b':'\u0438',
                        'n':'\u0442',
                        'm':'\u044c',
                        ',':'\u0431',
                        '.':'\u044e'

                       };
        }else{
            replaceArr={'\u0439':'q',
                        '\u0446':'w',
                        '\u0443':'e',
                        '\u043a':'r',
                        '\u0435':'t',
                        '\u043d':'y',
                        '\u0433':'u',
                        '\u0448':'i',
                        '\u0449':'o',
                        '\u0437':'p',
                        '\u0445':'[',
                        '\u044a':']',
                        '\u0451':'`',
                        '\u0444':'a',
                        '\u044b':'s',
                        '\u0432':'d',
                        '\u0430':'f',
                        '\u043f':'g',
                        '\u0440':'h',
                        '\u043e':'j',
                        '\u043b':'k',
                        '\u0434':'l',
                        '\u0436':';',
                        '\u044d':"'",
                        '\u044f':'z',
                        '\u0447':'x',
                        '\u0441':'c',
                        '\u043c':'v',
                        '\u0438':'b',
                        '\u0442':'n',
                        '\u044c':'m',
                        '\u0431':',',
                        '\u044e':'.'

                       };
        }
        var newstring=terms.toLowerCase()
    	aryText = new Array(newstring.length)
        for (i = 0; i < newstring.length; i++) {
            aryText[i] = newstring.charAt(i)
        }

        output='';
        for (var i in aryText){
            if (replaceArr.hasOwnProperty(aryText[i])){
                output=output.concat(replaceArr[aryText[i]])
            }else{
                output=output.concat(aryText[i])
            }
        }
        return output;
    },


    getInitialResultSet: function(terms) {
        var newterms=Array();
        newterms[0]=terms[0]
        oldterms0=newterms[0]
        newterms[0]=this._swichlayout(newterms[0])
	global.log(oldterms0+' -> '+newterms[0])
        if (newterms[0]!=oldterms0){
            return searchProviders[0].getInitialResultSet(newterms)
        }else{
            return [];
        }
	
    },

    getSubsearchResultSet: function(previousResults, terms) {
        var newterms=Array();
        newterms[0]=terms[0]
        oldterms0=newterms[0]
        newterms[0]=this._swichlayout(newterms[0])
global.log(oldterms0+' -> '+newterms[0])
        if (newterms[0]!=oldterms0){
            return searchProviders[0].getSubsearchResultSet(previousResults, newterms)
        }else{
            return [];
        }
    },

    getResultMeta: function(resultId) {
	return searchProviders[0].getResultMeta(resultId)
    },

    activateResult: function(resultId) {
	
        searchProviders[0].activateResult(resultId) 
    },

    _asyncCallback: function(events) {
	
    }
};


function ruenSearchProvider() {
    this._init();
}

ruenSearchProvider.prototype = {
    __proto__: langSearchProvider.prototype,

    _init: function() {
        let interpretations = ['ru'];
        langSearchProvider.prototype._init.call(this, _("EN->RU"), interpretations);
    }
};

function enruSearchProvider() {
    this._init();
}

enruSearchProvider.prototype = {
    __proto__: langSearchProvider.prototype,

    _init: function() {
        let interpretations = ['en'];
        langSearchProvider.prototype._init.call(this, _("RU->EN"), interpretations);
    }
};

var spruen=new ruenSearchProvider()
var spenru=new enruSearchProvider()

function init() {

}

function enable() {
    Main.overview._viewSelector._searchTab.addSearchProvider(spruen);
    Main.overview._viewSelector._searchTab.addSearchProvider(spenru);
}

function disable(){
    Main.overview._viewSelector._searchTab.removeSearchProvider(spruen)
    Main.overview._viewSelector._searchTab.removeSearchProvider(spenru)
}
